package be.oniryx.lean.utils;

import be.oniryx.lean.entity.ActivityReport;
import be.oniryx.lean.entity.Person;
import be.oniryx.lean.entity.Project;
import be.oniryx.lean.entity.Week;
import be.oniryx.lean.session.ActivityReportManagerActionTest;
import be.oniryx.lean.session.Factories;
import be.oniryx.lean.utils.MavenArtifactResolver;

//import com.acme.logic.framework.AbstractEntityListService;
//import com.acme.logic.framework.AbstractEntityListServiceBean;
//import com.acme.model.AbstractEntity;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.Archive;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.spec.EnterpriseArchive;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.jboss.shrinkwrap.api.spec.WebArchive;
import org.junit.runner.RunWith;

/**
 * Seam 2 Base class for integration tests. Will be executed within container. Test includes required files, only.
 *
 * @author <a href="mailto:michaelschuetz83@gmail.com">Michael Schuetz</a>
 */
@RunWith(Arquillian.class)
public abstract class AbstractSeamItTest {

    public static final String MAVEN_SEAM_ARTIFACT="org.jboss.seam:jboss-seam:2.1.0.GA";
    private static final String MAVEN_ARTIFACT_JBOSS_EL = "org.jboss.el:jboss-el:2.0.2.CR1";

//    protected static final Logger LOG = Logger.getLogger(AbstractSeamItTest.class.getName());

    protected static Archive<?> getTestArchive(final Class... clazzes) {

      // WAR
          final WebArchive war = ShrinkWrap.create(WebArchive.class, "test.war")
                  .setWebXML("war/web.xml")
                  .addWebResource("war/components.xml");

          // EJB-JAR
          final JavaArchive ejb = ShrinkWrap.create(JavaArchive.class,"test.jar")
                    .addClasses(ActivityReportManagerActionTest.class,
                    ActivityReport.class,
                    Person.class,
                    Project.class,
                    Week.class,
                    Factories.class) //,ActivityReportManager.class,ActivityReportManagerAction.class)
                    .addResource("jar/seam.properties" , "seam.properties")
//                    .addResource("components.properties" , "components.properties")
                    .addManifestResource("jar/ejb-jar.xml")
                    .addManifestResource("jar/persistance.xml");

          // EAR
          final EnterpriseArchive ear = ShrinkWrap.create(EnterpriseArchive.class , "test.ear")
                  .addModule(ejb)
                  .addModule(war)
                  .addManifestResource("jboss-app.xml")
                  .addModule(MavenArtifactResolver.resolve(MAVEN_SEAM_ARTIFACT));

          return ear;
    }
}
